import { type ReactNode } from 'react';
import { TFlags } from '@flopflip/types';
import { type ApplicationWindow, type CustomViewData } from '@commercetools-frontend/constants';
import { type TAsyncLocaleDataProps } from '@commercetools-frontend/i18n';
type TCustomViewShellAuthenticatedProps = {
    dataLocale: string;
    environment: ApplicationWindow['app'];
    messages: TAsyncLocaleDataProps['applicationMessages'];
    projectKey?: string;
    flags?: TFlags;
    customViewConfig: CustomViewData;
    children: ReactNode;
};
declare function CustomViewShellAuthenticated(props: TCustomViewShellAuthenticatedProps): import("@emotion/react/jsx-runtime").JSX.Element;
export default CustomViewShellAuthenticated;
