import { Component, ErrorInfo, ReactNode } from 'react';
type Props = {
    pathname?: string;
    children: ReactNode;
};
type State = {
    hasError: boolean;
};
declare class ErrorBoundary extends Component<Props, State> {
    static getDerivedStateFromError(): {
        hasError: boolean;
    };
    state: {
        hasError: boolean;
    };
    componentDidUpdate(prevProps: Props): void;
    componentDidCatch(error: Error, errorInfo: ErrorInfo): void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default ErrorBoundary;
