import { ReactNode } from 'react';
import type { ApolloError } from '@apollo/client/errors';
import type { TFetchLoggedInUserQuery } from '../../types/generated/mc';
type RenderFnArgs = {
    isLoading: boolean;
    error?: ApolloError;
    user: TFetchLoggedInUserQuery['user'];
};
type TFetchUserProps = {
    children: (args: RenderFnArgs) => ReactNode;
};
declare const FetchUser: {
    (props: TFetchUserProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default FetchUser;
