import { JSX, ReactNode } from 'react';
import type { TProviderProps } from '@commercetools-frontend/application-shell-connectors';
import type { TFetchLoggedInUserQuery } from '../../types/generated/mc';
type TProjectContainerProps = {
    user: TFetchLoggedInUserQuery['user'];
    environment: TProviderProps<{
        enableSignUp?: boolean;
    }>['environment'];
    disableRoutePermissionCheck?: boolean;
    render?: () => JSX.Element;
    children?: ReactNode;
};
declare const ProjectContainer: {
    (props: TProjectContainerProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default ProjectContainer;
