export declare const DIMENSIONS: {
    readonly header: "56px";
};
export declare const NAVBAR: {
    readonly expanderHeight: "50px";
    readonly expanderSize: "40px";
    readonly iconSize: "24px";
    readonly iconSizeHover: "28px";
    readonly itemSize: "48px";
    readonly itemHeight: "56px";
    readonly sublistIndentationWhenCollapsed: "72px";
    readonly sublistIndentationWhenExpanded: "248px";
    readonly sublistItemMinHeight: "50px";
    readonly sublistWidth: "272px";
    readonly leftNavigationTransition: "all 150ms cubic-bezier(1, 0, 0.58, 1)";
    readonly widthLeftNavigation: "80px";
    readonly widthLeftNavigationWhenExpanded: "256px";
};
export declare const WINDOW_SIZES: {
    readonly STANDARD: 1024;
    readonly WIDE: 1200;
};
export declare const CONTAINERS: {
    readonly LOCALE_SWITCHER: "locale-switcher-container";
    readonly LEFT_OF_PROFILE: "left-of-profile";
};
export declare const SUSPENSION_REASONS: {
    readonly TEMPORARY_MAINTENANCE: "TemporaryMaintenance";
    readonly PAYMENT: "Payment";
    readonly OTHER: "Other";
};
export declare const OIDC_RESPONSE_TYPES: {
    readonly ID_TOKEN: "id_token";
};
export declare const OIDC_CLAIMS: {
    readonly OPEN_ID: "openid";
    readonly PROJECT_KEY: "project_key";
    readonly TEAM_ID: "team_id";
    readonly APPLICATION_ID: "application_id";
    readonly VIEW: "view";
    readonly MANAGE: "manage";
};
