'use strict';

var applicationShellConnectors = require('@commercetools-frontend/application-shell-connectors');

const useIsServedByProxy = () => {
  const servedByProxy = applicationShellConnectors.useApplicationContext(context => context.environment.servedByProxy);
  return servedByProxy;
};

exports.useIsServedByProxy = useIsServedByProxy;
