import { JSX, ReactNode } from 'react';
import type { TProviderProps } from '@commercetools-frontend/application-shell-connectors';
type TApplicationEntryPointProps = {
    environment: TProviderProps<{}>['environment'];
    disableRoutePermissionCheck?: boolean;
    render?: () => JSX.Element;
    children?: ReactNode;
};
declare const ApplicationEntryPoint: (props: TApplicationEntryPointProps) => import("@emotion/react/jsx-runtime").JSX.Element | null;
export default ApplicationEntryPoint;
