import { ReactNode } from 'react';
import type { ReducersMapObject } from 'redux';
type Props = {
    id: string;
    reducers: ReducersMapObject;
    shouldCleanUpOnUnmount?: boolean;
    children: ReactNode;
};
declare const InjectReducers: {
    ({ shouldCleanUpOnUnmount, ...props }: Props): import("@emotion/react/jsx-runtime").JSX.Element | null;
    displayName: string;
};
export default InjectReducers;
