import { type ControllerStateAndHelpers } from 'downshift';
import type { TUser } from '../../types/generated/mc';
type Props = Pick<TUser, 'language' | 'firstName' | 'lastName' | 'email' | 'gravatarHash'>;
type MenuBodyProps = Props & {
    downshiftProps: ControllerStateAndHelpers<{}>;
};
declare const UserAvatar: {
    (props: Pick<Props, 'firstName' | 'lastName' | 'gravatarHash'>): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
declare const UserSettingsMenuBody: {
    (props: MenuBodyProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
declare const UserSettingsMenu: {
    (props: Props): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default UserSettingsMenu;
export { UserAvatar, UserSettingsMenuBody };
