import { type ReducersMapObject, type Store, type Middleware, type StoreEnhancer } from '@reduxjs/toolkit';
export type TEnhancedStore = Store & {
    injectedReducers: {
        [key: string]: ReducersMapObject;
    };
    injectReducers: (payload: {
        id: string;
        reducers: ReducersMapObject;
    }) => void;
    removeReducers: (payload: {
        id: string;
    }) => void;
};
/**
 * @deprecated: This function should not be used directly anymore.
 */
export declare const applyDefaultMiddlewares: (...middlewares: Middleware[]) => StoreEnhancer<{
    dispatch: unknown;
}, {}>;
export declare const createReduxStore: (preloadedState?: {}, additionalMiddlewares?: Middleware[]) => TEnhancedStore;
declare const _default: TEnhancedStore;
export default _default;
